import React, { useEffect, useState } from 'react';
import './App.scss';



const Input = () => {
  const [text, setText] = useState('text');
  return <div>
    <h1>{text}</h1>
    <input value={text} onChange={e => setText(e.target.value)} />
  </div>
  
}
const LoginForm = ({onLogin}) => {
  const [login, setLogin] = useState('');
  const [pswd, setPswd] = useState('');

  return <div>
      <input value={login} onChange={e => setLogin(e.target.value)}/> 
      <input value={pswd} onChange={e => setPswd(e.target.value)}/>
      <button disabled={login.length<3 || pswd.length<8 ? true:""} onClick={() => onLogin(login,pswd)}>Login</button>   
  </div>
}

const Counter = ({ms=1000}) => {
  const [counter, setCounter] = useState(0)
  useEffect(() => {
   const interval = setInterval (() => setCounter(counter => counter+1), ms)
    return () => {
      console.log('DID UNMOUNT')
      clearInterval(interval)
    }
  }, [ms])
  /* setInterval (() => setCounter(counter+1), 1000) */
  return (
    <div>{counter}</div>
  )
}
const Spoiler = ({header="+",children, opened=true}) => {
  const [open, setOpen] = useState(opened)
  return (
    <div>
        <div onClick={()=>setOpen(!open)}>{header}</div>
        {open && children}
    </div>
  )
}

const Counters = () => {
  const [cntrs, setCntrs] = useState([])
  const [ms, setMs] = useState(1000)
  return (
    <div>
      <button onClick={() => setMs(ms+100)}>+</button>
      <button onClick={() => setMs(ms-100)}>-</button>
      {cntrs.map(() => <Counter/>)}
      <button onClick={() => setCntrs([...cntrs, cntrs.length])}>Add</button>
    </div>
  )
}

const RangeInput = ({min,max}) => {
  const [value, SetValue] = useState(0);
  let color = "white";
  console.log(value);
  /* useEffect(() => {
    if(value < min || value > max){
        color = "red";
        console.log(color);
    } else {
      color = '';
    }
  }, [value]) */
  if(value < min || value > max) {
    color = "red"
    console.log(color);
  } else {
    color = "";
  }
  return (
    <input onChange={e => SetValue(e.target.value.length)} style={{backgroundColor:color}}/>
  )
}


function App () {
  return(
    <div className='App'>
      {/* <Input/> */}
      {/* <LoginForm onLogin={(login, password) => console.log(login,password)}/> */}
      <Spoiler header={<h1>Hello</h1>} opened={false}>
        <h1>Hello</h1>
        <p>blabla</p>
      </Spoiler>
      <RangeInput min={2} max={10}/>
    </div>
  );
}
export default App;
